"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAcyclicGraph = void 0;
function isAcyclicGraph(links) {
    var _loop_1 = function () {
        var sourceToTargetsMap = links.reduce(function (acc, _a) {
            var sourceId = _a.sourceId, targetId = _a.targetId;
            acc[sourceId] = acc[sourceId] || [];
            acc[sourceId].push(targetId);
            return acc;
        }, {});
        var allNodes = Object.keys(links
            .map(function (l) { return [l.sourceId, l.targetId]; })
            .reduce(function (acc, cur) {
            cur.forEach(function (c) { return (acc[c] = true); });
            return acc;
        }, {}));
        var nodesWithoutOutgoingLink = allNodes
            .filter(function (n) { return !(sourceToTargetsMap[n] && sourceToTargetsMap[n].length > 0); })
            .reduce(function (acc, cur) {
            acc[cur] = true;
            return acc;
        }, {});
        var newLinks = links.filter(function (l) { return !nodesWithoutOutgoingLink[l.targetId]; });
        if (newLinks.length === links.length) {
            return { value: false };
        }
        links = newLinks;
    };
    while (links.length > 0) {
        var state_1 = _loop_1();
        if (typeof state_1 === "object")
            return state_1.value;
    }
    return true;
}
exports.isAcyclicGraph = isAcyclicGraph;
